Directory Report home page: http://www.file-utilities.com

Directory Report Help

Auto Print

You can direct Directory Report to automatically print any screen to a file after scanning directories is done

To set this option select menu : Print / autoprint

This feature is very useful when starting Directory Report as a batch job (From the command line)

Directory Report is started from the command line as
"Full path to wDirReport.exe" "full path to settings file"

Example:
"C:\Program Files\AMB Software\Directory Report\wDirReport.exe" "c:\temp\wdir.txt"

Saving program settings

You can save all program options by selecting menu: File / Save Settings
You can load all saved program options by selecting menu: File / Load Settings


Directory Report home page

Multiple File Change Owner

  1. Select 1 or many files and directories
  2. Right click and select from the popup menu: Change Owner

  3. or Select pull down menu item: File / Change Owner

  4. Enter the new owner name
    The domain name is optional


CRC Cylic Redundancy Checksum

CRC

Directory Report can calculate a file's Cyclic Redundancy Checksum (CRC).

Each byte of the file is passed through the CRC formula (CRC-32).
The result is a unique 32 bit number.
Any change to the file will result in a different CRC.

If two files have the same CRC then they are identical.
Since the CRC is a 32 bit number there are 4294967296 possible values
Thus the odds that two different files have the same CRC are 1 out of 4294967296
Thus the CRC-32 is 4294967295 / 4294967296 = 0.99999999976716935634613037109375% accurate

You can check if two files on two computers are identical by running Directory Report on both machines and calculating their CRC.
This is very useful if you want to check if files on a customer's computer has been corrupted.
You don't have to run a binary compare on the two files especially if the two computers are not on a common network

You can check if a file has been corrupted by checking its CRC and comparing it to previous values

For files that you don't have permission to open
Their CRC is displayed as: UNKNOWN

The CRC feature is turned on / off by selecting the "Summation" button on the toolbar or by selecting menu: CRC / Compute CRC

There are two CRCs calculated for directories

  • CRC

    This is a CRC of each file's CRC in the directory.
    Files in subdirectories are not processed.
  • CRC wSub

    This is a CRC of each file's and of each subdirectory in the directory
    This includes all files and all subdirectories

If two directories have the same CRC then they are identical.
That is they have the identical number of file / subdirectories
And all files in both directories are identical


CRC from a file

Loading a list of CRCs from a file

If you have files whose CRC never changes, you can load their CRC from a file
This saves you the time by not computing their CRC
This will speed up finding duplicate files by CRC
This is very useful for files residing on read-only media (CD, DVD)

The file is loaded by selecting menu: CRC / Get CRCs from a file

There are two file formats: text and XML
Just enter a file name whose extension is .txt or .xml
Both formats can be used unchanged from a Directory Report output

Sample Text format:
Other attributes are allowed
You don't have to have just the CRC attribute
You MUST save your output with FULL file names

c:\temp\dr_crc.txt
CRC: 2235611783

c:\temp\dr_byte.txt
CRC: 368897331

c:\temp\dr_dup.txt
CRC: 489131756

Sample XML format:
Other attributes are allowed
You don't have to have just the CRC attribute

<file name='c:\temp\dr_crc.txt'
crc='2235611783'
/>
<file name='c:\temp\dr_byte.txt'
crc='368897331'
/>
<file name='c:\temp\dr_dup.txt'
crc='489131756'
/>

How to know if a CRC is computed or read from a file

Select a file, right click and select: properties
The following text is shown if the CRC is read from a file

CRC is not computed, it is read from a file


Comparing Directories

  1. Scan your directories
  2. Select menu: Compare
  3. Select menu item: Compare Directories or
    Select menu item: Compare Directories (with subdirectories)
  4. Select two directories to compare

    or

    Select two directories in any window
    Right click and select from the popup menu:
    Select "Compare Directories" or
    Select "Compare Directories (with subdirectories)"
  5. If you entered two root directories,
    then they are preselected

  6. If you only selected 1 or more than two root directories,
    then you have to select which directories to compare

    For example: you selected only 1 root directory to scan (c:\temp2)
    The following dialog is presented

  7. Open the c:\temp2 folder

  8. Select the folder: a1
  9. Click on the button: Select Directory
  10. This will enter the folder c:\temp2\a1 in the first Directory editbox
    and the radio button for "Pick directory 2" will be set

  11. Select folder: a2
  12. Click on the button: Select Directory
  13. This will enter the folder c:\temp2\a2 in the second Directory editbox

  14. Click on the button: OK
    This will start the compare of the two directories
  15. The default comparison mode is to do an ASCII compare of files with the same name
    The line number will be shown at which a difference is found
  16. To change the default comparison mode
    Before you scan the directories
    Select menu: Compare / Set Default Compare Mode
  17. You can choose from:
    ASCII-Line by Line (Ignore leading and trailing blanks)
    ASCII-Line by Line
    Binary
  18. If the comparison mode is binary then
    The byte number will be shown at which a difference is found
    else
    If the comparison mode is ASCII then
    The line number will be shown at which a difference is found
  19. To visually see what the difference are
    Double click on a line


Duplicate Files

Showing duplicate files

  1. Scan your directories
  2. Select menu: Duplicates / Show duplicate options ...

  3. This will display the following dialog

  4. Select any combination of methods in the "Find Duplicate Files By" box

    The CRC (Excluding MP3 tags) will calculate the file's CRC
    It will skip over old MP3 tags (last 128 bytes starting with "TAG")
    It will skip over new MP3 tags (first 3 bytes starting with "ID3")

    CRC = Cyclic Redundancy Checksum.
    This formula passes each byte of the file through the CRC-32 formula and generates a 32 bit checksum.
    Any change in any byte of the file will result in a different checksum.
    The CRC-32 formula is the same one used by the WinZip program
    The CRC method is slow since it requires reading each byte of the file
    Directory Report uses multiple passes to quickly eliminate non-duplicates
    Directory Report uses multiple threads to calculate CRC as fast as possible

    Since the CRC generated is 32 bits, there are 4,294,967,296 possible values.
    Thus the odds of two different files having the same CRC is: 1 / 4,294,967,296
    Thus the CRC method is: (1 - (1 / 4,294,967,296)) * 100 = 99.999999976716935634613037109375% accurate

    Therefore to be absolutely sure that two files are identical,
    Directory Report has an option to compare them byte by byte
  5. Select menu: Duplicates / Find duplicate files

  6. The Duplicate Files screen is shown
    The files are grouped by methods chosen in step 3
    Each group is sorted by decreasing size order

  7. If you close the Duplicate files screen
    and want to redisplay the duplicate files found earlier

    Select menu: Duplicate / Show duplicate files

8. You can turn on/off coloring by selecting menu: Duplicates / Show Duplicates in Color

9. How to easily select multiples files for deletion

You can select multiple duplicate files for deletion by selecting menu
Duplicates / Select files in each duplicate group...


Duplicate Files Filter

You can select a list of files or a list of directories as a duplicate files filter

Then when you scan your root directories - only files which are duplicates will be shown

This saves you scanning for duplicates of an entire disk

Here are the steps:

  • Select menu: Filters / Duplicate Files Filter

    Select one or many files

    or
  • Select menu: Filters / Duplicate Directories Filter

    Select one or many directories

    Each file in these directories will be a filter
  • CRC will be used to determine if files are duplicates


Duplicate Directories

Showing duplicate directories

  1. Scan your directories
  2. Select menu: Duplicates / Show duplicate options...

  3. This will display the following dialog

  4. Select any combination of methods in the "Find Duplicate Directories By" box

    CRC = Cyclic Redundancy Checksum.
    This formula passes each byte of the file through the CRC-32 formula and generates a 32 bit checksum.
    Any change in any byte of the file will result in a different checksum.
    The CRC-32 formula is the same one used by the WinZip program
    The CRC method is slow since it requires reading each byte of the file
    Directory Report uses multiple passes to quickly eliminate non-duplicates
    Directory Report uses multiple threads to calculate CRC as fast as possible

    Since the CRC generated is 32 bits, there are 4,294,967,295 possible values.
    Thus the odds of two different files having the same CRC is: 1 / 4,294,967,295
    Thus the CRC method is: (1 - (1 / 4,294,967,295)) * 100 = 99.999999976716935629192026245685% accurate
  5. Select menu: Duplicate / Find duplicate directories

  6. The duplicate Directories screen is shown
    The directories are grouped by methods chosen in step 3
    Each group is sorted by decreasing size order

  7. If you close the Duplicate Directories screen
    and want to redisplay the duplicate directories found earlier

    Select menu: Duplicate / Show duplicate directories

8. You can turn on/off coloring by selecting menu: Duplicates / Show Duplicates in Color

9. How to easily select multiple directories for deletion

You can select multiple directories for deletion by selecting menu
Duplicates / Select directories in each duplicate group...


Filters

By default, Directory Report scans all files.
You can narrow down the files scanned by filtering in or filtering out files
Select menu: Filters

Example:

Only scan files that have an mp3 extension
Select menu: Filters / File Name Filters

Directory Report will then only show directories with mp3 files
But you must remember that you have applied a filter,
and that the directory may have many other files of other types

So before deleting directories, please remember if you have applied a filter.
When in doubt, you can send the directory to the MS Explorer (Right click / Sendto MS-Explorer)
The MS Explorer will show all files


Icons

Directory Report does not show the icon associated with a file's extension
since this would slow down the program when displaying a large list of files

The following icons are shown

This is the icon for a system file

This is the icon for a compressed file

This is the icon for a system directory

This is the icon for a compressed directory

This is the icon for an encrypted directory

This is the icon for a protected directory
This directory exists, but its contents cannot be retrieved

The globe is the icon for a file that contains streams
The water faucet is the icon for a stream

The NTFS file system has a feature called streams
All files have a an unnamed stream
This unnamed stream's attributes are what you see with the MS Explorer
The MS Explorer is incapable of displaying any of the file's streams
Thus a file can have a 100 megabyte stream and you would not know it

Checking for streams is off by default since this slows down the scanning of directories
To enable the checking of streams select menu: File / Check for Streams

To filter for files containing streams select menu:
Filters / Size, Date and other Filters
Set the checkbox: File has NTFS streams

To create a stream:

Create a file my_stream.txt (2 bytes in size)
Enter: dir > my_stream.txt:a
Enter: dir > my_stream.txt:b


Largest Files

Showing the largest files

  1. Scan your directories
  2. Select menu: Largest / Display Largest Files

The menu item "Set Largest Files Count" will allow you to compute only the N largest files. The default is to compute all of the largest files scanned.


Largest Directories

Showing the largest directories

  1. Scan your directories
  2. Select menu: Largest / Display Largest Directories

The menu item "Set Largest Directoriess Count" will allow you to compute only the N largest directories. The default is to compute all of the largest files scanned.


Largest Owner

To determine which user has the most files and the most bytes used:

  1. Select menu: Largest / Compute Largest Owner

    This will get the owner of each file scanned
    Getting the owner is off by default since getting the owner takes extra time

  2. Scan your directories
  3. Select menu: Largest
  4. Select menu item: Display Largest Owner

To display all files sorted by file owner

  1. Select menu: Largest / Compute Largest Owner
  2. Scan your directories
  3. Click on the toolbar's "Show Owner" button
    This button is off by default
    This looks like a boy and girl

  4. Select menu: Largest
  5. Select menu item: Display Largest Files
  6. Click on the List-Control's "Owner" column header
    This will sort the list by file owner


Largest Type

To determine which user has the most files and the most bytes used:

  1. Select menu: Largest / Compute Largest Type

    This will sum up bytes used per file extension (type)
    This is off by default since summing by type takes extra time

  2. Scan your directories
  3. Select menu: Largest / Display Largest Type

To display all files sorted by file type

  1. On any screen, select menu:
    Sort / Sort by Extension Ascending
    or
    Sort / Sort by Extension Descending


Directory Report home page

MP3 Rename

This feature will rename a file based on its MP3 ID3 tags
It can process the old and new MP3 tags

  1. Select 1 or more MP3 files
  2. Right click and select popup menu: MP3 Rename

  3. This will display the MP3 Rename Dialog


Multiple File Rename

  1. Select 2 or more files or 2 or more directories
  2. Right click and select popup menu: Multi Rename

  3. This will display the Multi Rename Dialog

  4. It highly recommended that you preview the file renaming before it is done
  5. The "Replace with" edit-box is preset to the file's directory name
    Example, setting the Replace with text to xxx will rename files as: xxx01.txt, xxx02.txt, xxx03.txt
  6. "File numbering" will rename files as: xxx00.txt, xxx01.txt, xxx02.txt
  7. The "Starting number" can be changed
    Example, setting the Starting Number to 10 will rename files as: xxx10.txt, xxx11.txt, xxx12.txt
  8. To keep all file names the same length you should set the "Number width"
    Example, setting the Number Width to 2 will rename files as: xxx08.txt, xxx09.txt, xxx10.txt
  9. The "Insert string" will insert text at the start of the file name
    You can set the Insert string index to insert text at any position
  10. The "Append string" will add text to the end of the file name
    The file name is the text before the ".extension"

  11. The file extension is the text from the trailing "." to the last character
  12. The "Replace with" will rename files
    from
    x1.jpeg, x2.jpeg, x3.jpeg

    to
    x1.jpg, x2.jpg, x3.jpg

  13. The character replacement tab allows you to replace individual characters
    You can do simple replacement or use powerful regular expression
  14. To add a new entry, right click and select popup menu: Add a new entry
  15. For help on regular expressions go to the help page for: Multi Rename Regular Expression


Regular Expression

Regular Expression

Characters | Definition
. | This matches any single character Example: b.d matches bad, bed, bbd
* | Zero or more of the preceding character or expression Example: ba*c matches bc, bac, baac
+ | One or more of the preceding character or expression Example: ba+c matches bac, baac, but not bc
^ | Start of line
$ | End of line
[] | Single character group Example: b[ae]d matches bad, bed, but not baed Example: b[ae]+d matches bad, bed, baad, beed and baed
[^] | Exclude single character group Example: b[^ae]d matches bit, bud, but not bad
[a-z] | Single character range a through z Example: b[a-c]d matches bad, bbd, bcd
{} | Multiple character group Example: b{ae}d matches baed, but not bad Example: b{ae}+d matches baed, baeaed
\t | tab
\f | formfeed
\ | Any character following a slash is actually that character Example: \. is a . not "Any single character" Example: \^ is a ^ not "Start of line" Example: \$ is a $ not "End of line"


Printing

All screens can be printed or saved to a:

  • Printer
  • Text file
  • Clipboard
  • Excel file (.csv)
  • Excel program
  • HTML file
  • XML file

Choosing which attributes to print / not to print

You can choose which properties to print / not-to-print by selecting menu: Print / Set Printing Flags. By default all attributes are printed

"Save As Unicode"

This is necessary if you are printing files/directories with international characters
Each character is printed as 2 bytes

If you are NOT printing files/directories with international characters
then turn this off and your output file will be half the size

Printing Font

You can choose the printing font by selecting menu: Print / Select Printing Fonts
This will also change the font of every screen of Directory Report

Printing widths

You can choose the printed widths of each attribute by selecting menu: Print / Select Printing Widths


Saving and loading settings

Saving and loading your settings

You can save all your settings to a text file by selecting the menu: File / Save Settings

You can load your settings by selecting the menu: File / Load Settings

Automatically running with a settings file

You can create a shortcut as:
"Full path to Directory Report Exe" "Full path to settings file"
Example: "C:\Program Files\AMB Software\Directory Report\wDirReport.exe" "C:\temp\wdir.txt"

or you can run Directory Report from a command window as:
"Full path to Directory Report Exe" "Full path to settings file"

then the settings file will be read in upon program startup


Scanning a directory

  1. Click on the binoculars button

  2. Select 1 or more directories

  3. Clicking on "OK" button will scan the directories
  4. There might be directories that are protected against scanning.
    These directories might be scanable if you run Directory Report as an administrator

The default method is to scan all subdirectories
If you do not want to scan all subdirectories
Select menu: Directory
Click on the menu item: Scan subdirectories
This will uncheck the menu item


Streams

The NTFS file system has a new feature called streams
All files have an unnamed stream
This unnamed stream's attributes are what you see with the MS Explorer
The MS Explorer is incapable of displaying any of the file's streams
Thus a file can have a 100 megabyte stream and you won't even know it

To create a stream:

Create a file my_stream.txt (2 bytes in size)
Enter: dir > my_stream.txt:a
Enter: dir > my_stream.txt:b

To view a stream:

Enter: more < my_stream.txt:a

The MS Explorer:
Is incapable of displaying any of the file's streams
Only shows the file's size as 2 bytes

With the Directory Report program you can:

  • Set a filter to only show files that have streams
    Select menu: Filters / Size, Date and Other Filters

By default when a file is scanned, it is not checked if it contains a stream.
To turn on this feature:
Select menu: File / Check for Streams

The sample my_stream.txt (shown above) would be shown as:

If you select the stream (file with the globe),
then you can save each stream element as a separate file:
Right click / Breakup streamed file

You can select a stream component (file with the water faucet),
then you can save the component as a separate file:
Right click / Save stream to file


Toolbar

This button will present a dialog
in which you can select the directories to scan

This button will save the contents of the current screen to a file
You will be prompted to save to a Text, Excel (.csv), or HTML

You can choose which attributes to print/not-to-print
by selecting menu: print / set printing flags

This button will rescan all directories

This button will open the parent folder of the current folder

This button will open all the folders in the TreeControl of the main screen

This button will close all the folders in the TreeControl of the main screen

This button will display a dialog in which you can search the current display for a file or a directory

This button will print the contents of the current screen.

You can choose which attributes to print/not-to-print
by selecting menu: print / set printing flags

This button will delete the currently selected files or folders
They will go to the recycle bin

To permanently delete files (without going to the recycle bin)
right click and select popup menu: Delete Selected Files (No recycle bin)

This button will enable the the CRC (Cyclic Redundancy Checksum) column.
Each byte is passed through the CRC formula generating a unique 32bit number.
Any change to the file, no matter how small, will generate a different CRC.
The CRC is used to determine if two file/directories are equal - Even if they are on two computers

There are two CRCs generated for folders
CRC - The CRC of all files excluding files in subfolders
CRC wSub - The CRC of all files including all files in all subfolders

The CRC feature is initially off by default
It may take a long time depending on the total size of the files needed to be scanned

This button will determine the owner of all files/folders displayed
If you want to determine the owner of all files (Even files not displayed)
then select menu: Largest / Compute Largest Owner

This feature is initially off by default
It can take a long time to determine file ownership on files on a network drive

This button will display the file version

This button will stop the program while it is scanning your directories


Diff program

Setting your own Diff program

Directory Report comes with a diff program (wDiff.exe)
This is used to compare ASCII files

You can use your own diff program by selecting menu:
Compare / Use your own diff program


FAQ

Frequently asked questions

Directory Report's license installation is done by the Softwrap company.
The following is from Softwrap's FAQ page
USA: 1 866 205 6310
World: (44) 207 089 4114
http://www.softwrap.com/faq.aspx?Category_ID=2&Section=Technical

Commands

Many commands are found by right clicking the mouse

Starting Directory Report from the command line

To start the program from the command line and use a settings file enter the full path to the program exe in double quotes and enter the full path to the settings file in double quotes:

Example
"C:\Program Files\AMB Software\Directory Report\wDirReport.exe" "c:\temp\settings.txt"

Memory usage

Directory report stores the name and attributes of each file and directory scanned
It can easily use a large amount of memory
You might have to increase the size of your paging file (Virtual Memory)

Duplicate Files/Directories

To speed up the search for duplicate files/directories, it highly recommended that you set a filter to limit the files scanned
Example: Set the minimum file size to 1,000,000 bytes

Saving program settings

You can save all program options by selecting menu: File / Save Settings

You can load all saved program options by selecting menu: File / Load Settings

How do I re-install software that I have purchased?

To re-install software that you have removed, you must re-run the software's original installation set-up. Softwrap™ will detect that you have previously bought this software and will automatically run in a purchased status.

What happens to purchased software when I re-install my computer?

You must re-install the software that has been removed, this must be done by re-running the software's original installation set-up. Softwrap™ will now detect this as a first time run. To get the software back to a purchased status, click the 'Buy-it' button. This will not put a charge through on your credit card, but will verify that you have previously bought the software for this specific computer.

Can I transfer the license from one machine to another?

By calling Softwrap support (USA: 1 866 205 6310, World: (44) 207 089 4114), they will instruct you on how to remove the license from one machine, and how to reinstall it on another machine


Installation support

Installation help

For installation help please call softwrap at:
USA + 1 866 205 6310
World + (44) 207 089 4114

or email: support@softwrap.com

or go to softwrap's webpage
http://www.softwrap.com
http://www.softwrap.com/faq


Linking files

Directory Report enables you to link a file to a new name

This is done by calling Microsoft's CreateHardLink

This will create a new directory entry but will not copy the contents of the file

The destination file cannot already exist

The destination file must be on the same drive as the source file

The link count is shown in the file properties dialog

You can set as a filter that a file is linked or is not linked
Select menu: Filters / Size, Date and Other Filters